#include <kavl_defs.h>

extern kavl_node_t *kavl_rebalance(kavl_node_t *);

static const int8_t abc[2][2] =
{
	{-1, +1},
	{+1, -1}
};

void
kavl_maintain(kavl_node_t **r, kavl_node_t *o, kavl_mode_t m)
{
	if (o)
	{
		kavl_node_t *p = (kavl_node_t *)(o->elnk[PAR] & ~pmsk);
		kavl_branch_t d;

		for (; p; p = (kavl_node_t *)(o->elnk[PAR] & ~pmsk))
		{
			d = (p->rlnk[RHT] == o);

			switch (o->elnk[PAR] & pmsk)
			{
			case LCR:
			case RCR:
				p->rlnk[d] = kavl_rebalance(o);

				if (m && ((p->rlnk[d]->elnk[PAR] & pmsk) != BAL))
				{
					return;
				}
			/* fall through  */

			case BAL:
				if (!m)
				{
					return;
				}
			break;

			default:
				if (m)
				{
					return;
				}
			break;
			} /* switch (...) */

			p->elnk[PAR] += abc[m][d];
			o = p;
		} /* for (...) */

		switch (o->elnk[PAR] & pmsk)
		{
		case LCR:
		case RCR:
			*r = kavl_rebalance(o);
		/* fall through */

		default:
		break;
		}
	}
}

