#include <kavl_defs.h>

static const kavl_balance_t src[2] =
{
	RHE,
	LHE
};

static const kavl_balance_t drc[2][2] =
{
	{LHE, RHE},
	{RHE, LHE}
};

static kavl_node_t *
kavl_rotate(kavl_node_t *n, kavl_branch_t d)
{
	kavl_node_t *c = n->rlnk[!d];
	kavl_node_t *p = (kavl_node_t *)(n->elnk[PAR] & ~pmsk);

	if ((n->rlnk[!d] = c->rlnk[d]))
	{
		c->rlnk[d]->elnk[PAR] &= pmsk;
		c->rlnk[d]->elnk[PAR] |= (uintptr_t)n;
	}

	c->rlnk[d] = n;
	n->elnk[PAR] &= pmsk;
	n->elnk[PAR] |= (uintptr_t)c;
	c->elnk[PAR] &= pmsk;

	if (p)
	{
		c->elnk[PAR] |= (uintptr_t)p;
		d = p->rlnk[RHT] == n;
		p->rlnk[d] = c;
	}

	return c;
}

kavl_node_t *
kavl_rebalance(kavl_node_t *n)
{
	kavl_branch_t ib = (n->elnk[PAR] & pmsk) > BAL;
	kavl_node_t *dc = n->rlnk[ib];

	if ((dc->elnk[PAR] & pmsk) == src[ib])
	{
		kavl_node_t *ic = dc->rlnk[!ib];

		n->elnk[PAR] &= ~pmsk;
		dc->elnk[PAR] &= ~pmsk;

		if ((ic->elnk[PAR] & pmsk) == drc[ib][0])
		{
			n->elnk[PAR] |= drc[ib][ib];
			dc->elnk[PAR] |= BAL;
		}
		else
		if ((ic->elnk[PAR] & pmsk) == drc[ib][1])
		{
			n->elnk[PAR] |=  BAL;
			dc->elnk[PAR] |= drc[ib][!ib];
		}
		else
		{
			n->elnk[PAR] |= BAL;
			dc->elnk[PAR] |= BAL;
		}

		ic->elnk[PAR] = (ic->elnk[PAR] & ~pmsk) | BAL;
		n->rlnk[ib] = kavl_rotate(dc, ib);
	}
	else
	if ((dc->elnk[PAR] & pmsk) == src[!ib])
	{
		n->elnk[PAR] = (n->elnk[PAR] & ~pmsk) | BAL;
		dc->elnk[PAR] = (dc->elnk[PAR] & ~pmsk) | BAL;
	}
	else
	if((dc->elnk[PAR] & pmsk) == BAL)
	{
		n->elnk[PAR] = (n->elnk[PAR] & ~pmsk) | src[!ib];
		dc->elnk[PAR] = (n->elnk[PAR] & ~pmsk) | src[ib];
	}

	return kavl_rotate(n, !ib);
}

