#include <kavl_defs.h>

extern void kavl_maintain(kavl_node_t **, kavl_node_t *, kavl_mode_t);

static const kavl_balance_t dc[2] =
{
	+1,
	-1
};

kavl_node_t *
kavl_remove(kavl_node_t **r, kavl_node_t *n)
{
	kavl_node_t *p;
	kavl_class_t nc;
	kavl_branch_t d = 0;

	if ((p = (kavl_node_t *)(n->elnk[PAR] & ~pmsk)))
	{
		d = (p->rlnk[RHT] == n);
	}

	nc = (n->rlnk[LFT] ? 1 : 0);
	nc += (n->rlnk[RHT] ? 1 : 0);

	switch (nc)
	{
	case SUBT:
	{
		kavl_node_t *rn = n->rlnk[LFT];
		kavl_branch_t rd;
		kavl_node_t *rp;

		for (; rn->rlnk[RHT]; rn = rn->rlnk[RHT]);

		rp = (kavl_node_t *)(rn->elnk[PAR] & ~pmsk);
		rd = (rp->rlnk[RHT] == rn);

		if (rn->rlnk[LFT])
		{
			rp->rlnk[rd] = rn->rlnk[LFT];
			rn->rlnk[LFT]->elnk[PAR] &= pmsk;
			rn->rlnk[LFT]->elnk[PAR] |= (rn->elnk[PAR] & ~pmsk);
			rp->elnk[PAR] += dc[rd];
		}
		else
		{
			rp->elnk[PAR] += dc[rd];
			rp->rlnk[rd] = (kavl_node_t *)0;
		}

		rn->elnk[PAR] = n->elnk[PAR];

		if (p)
			p->rlnk[d] = rn;
		else
			*r = rn;

		for (d = 0; d < 2; d++)
		{
			if ((rn->rlnk[d] = n->rlnk[d]))
			{
				rn->rlnk[d]->elnk[PAR] &= pmsk;
				rn->rlnk[d]->elnk[PAR] |= (uintptr_t)rn;
			}
		}

		p = (rp == n ? rn : rp);
	}
	break;

	case BNCH:
	{
		kavl_branch_t sd = (n->elnk[PAR] & pmsk) > BAL;
		n->rlnk[sd]->elnk[PAR] &= pmsk;

		if (p)
		{
			n->rlnk[sd]->elnk[PAR] |= (uintptr_t)p;
			p->elnk[PAR] += dc[d];
			break;
		}
		*r = n->rlnk[sd];
	}
	break;

	case LEAF:
		if (p)
		{
			p->rlnk[d] = (kavl_node_t *)0;
			p->elnk[PAR] += dc[d];
			break;
		}
		*r = (kavl_node_t *)0;
	break;
	} /* switch(nc) */

	kavl_maintain(r, p, REM);
	return n;
}

