#ifndef _H_KDT
#define _H_KDT

#include <stdlib.h>
#include <stdint.h>
#include <string.h>

typedef
struct kdtab_t
{
	uint8_t *raw;
	uintptr_t used;
	uintptr_t claimed;
}
kdtab_t;

extern kdtab_t *kdt_create(uintptr_t);
extern void kdt_destroy(kdtab_t *);

#define kdt_typed_insert(dat,typ,tab) (typ *)kdt_insert(dat, sizeof(typ), tab)
#define kdt_typed_index(idx,typ,tab) (typ *)kdt_index(idx, sizeof(typ), tab)

extern void *kdt_insert(void *, uintptr_t, kdtab_t *);
extern void *kdt_index(uintptr_t, uintptr_t, kdtab_t *);
extern void kdt_wrap(kdtab_t *);

#endif /* _H_KDT */

