#include <kdt.h>

void *
kdt_insert(void *d, uintptr_t sz, kdtab_t *tab)
{
	uint8_t *tmp_ref;

	if ((tab->used + sz) >= tab->claimed)
	{
		uintptr_t desired_sz = (tab->used + sz) << 1;
		uintptr_t new_sz = tab->claimed;
	
		for (; new_sz < desired_sz; new_sz <<= 1);
		
		if (!(tmp_ref = realloc(tab->raw, new_sz)))
			return (void *)0;
			
		tab->raw = tmp_ref;
		tab->claimed = new_sz;
	}
	
	tmp_ref = &tab->raw[tab->used];
	memcpy(tmp_ref, d, sz);
	tab->used += sz;

	return (void *)tmp_ref;	
}

