#ifndef _H_KMMWPR
#define _H_KMMWPR

/*
 * elderK's MM Wrapper
 * :: Several of my implementations (radix, etc) require the use of
 * :: this structure; its sole purpose is to abstract memory management
 * :: calls. As seen below, the structure defines two function pointers,
 * :: acquire() and release().
 * ::
 * :: Programs using this wrapper expect the acquire function to return
 * :: a block sized appropriately to the application.
 * ::
 * :: The function that acquire references _must_ return 0 on failure.
 * :: 
 * :: release, like acquire, is application specific and obviously must
 * :: deallocate or otherwise release the asset referenced in the void *
 * :: parameter. Said parameter _must_ be a block that was allocated via
 * :: the acquire function.
 */

typedef
struct k_alloc_t
{
	void *(* acquire)(void);
	void (* release)(void *);
}
k_alloc_t;

#endif /* _H_KMMWPR */

