#ifndef _H_KRADIX
#define _H_KRADIX

#include <stdint.h> /* for uintN_t, uintptr_t */
#include <string.h> /* for memcmp */

#include <kmmwpr.h> /* for k_alloc_t */

typedef
struct krdx_node_t
{
	union
	{
		struct
		{
			uintptr_t dpos;
			struct krdx_node_t *lnk[2];
		}
		inn;

		struct
		{
			void *key, *dat;
			uintptr_t keylen;
		}
		exn;
	}
	mun;

	union
	{
		uintptr_t flg;
		struct krdx_node_t *prnt;
	}
	pun;
}
krdx_node_t;

#define par pun.prnt
#define flg pun.flg
#define inn mun.inn
#define exn mun.exn

/* radix node types */
enum krdx_class_t
{
	EXTERN,
	INTERN,
	MARKED,
	JUNK
};

/* mm-independent node creation/destruction via k_alloc_t */
extern krdx_node_t *krdx_create(void *, uintptr_t, void *, k_alloc_t *);
extern void krdx_destroy(krdx_node_t *, k_alloc_t *);

extern krdx_node_t *krdx_insert(krdx_node_t **, krdx_node_t *, k_alloc_t *);
extern krdx_node_t *krdx_locate(krdx_node_t **, void *, uintptr_t);
extern krdx_node_t *krdx_remove(krdx_node_t **, krdx_node_t *, k_alloc_t *);

#endif /* _H_KRADIX_ */

