#include <krdx.h>

extern krdx_node_t **krdx_traverse(krdx_node_t **, void *, uintptr_t);

krdx_node_t *
krdx_insert(krdx_node_t **r, krdx_node_t *n, k_alloc_t *a)
{
	krdx_node_t *intn = n;

	if (*(r = krdx_traverse(r, n->exn.key, n->exn.keylen)))
	{
		uintptr_t *elen, dpos;
		uint8_t *nkey = n->exn.key;
		uint8_t *rkey = (*r)->exn.key;

		if (!(intn = a->acquire()))
			return (krdx_node_t *)0;
		else
			intn->flg = (*r)->flg & ~7;

		if ((*r)->exn.keylen < n->exn.keylen)
			elen = &(*r)->exn.keylen;
		else
			elen = &n->exn.keylen;

		for (dpos = 0; dpos < *elen; rkey++, nkey++, dpos++)
		{
			if ((*rkey ^ *nkey))
			{
				uint8_t kdiff = *rkey ^ *nkey;
				for (dpos <<= 3; !(kdiff & 1); kdiff >>= 1, dpos++);

				intn->flg |= INTERN;
				
				intn->inn.lnk[0] = (*nkey & (1 << (dpos & 7)) ? *r : n);
				intn->inn.lnk[1] = (*nkey & (1 << (dpos & 7)) ? n : *r);
			}
		}
		
		if (!(intn->flg & 7))
		{
			if ((*r)->exn.keylen == n->exn.keylen)
			{
				a->release((void *)intn);
				return (krdx_node_t *)0;
			}

			intn->flg |= MARKED;
			intn->inn.lnk[0] = (elen != &n->exn.keylen ? n : *r);
			intn->inn.lnk[1] = (elen == &n->exn.keylen ? n : *r);
		}

		intn->inn.lnk[0]->flg =
				intn->inn.lnk[1]->flg = (uintptr_t)intn | EXTERN;

		intn->inn.dpos = dpos;
	}
	*r = intn;

	return n;
}

