#include <inj.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

static void
StampFile(const char *Path)
  {
    char *Name = RootDir->Name;
    for (; *Path && Name < &RootDir->Name[11]; Path++)
    {
        if (*Path == '.')
            Name = &RootDir->Name[8];
        else
            *Name++ = toupper(*Path);
    }

    time_t CurrentTime = time((time_t *)0x0);
    struct tm *TimeInfo = localtime(&CurrentTime);

    RootDir->LastWriteTime |= (TimeInfo->tm_sec >> 1);
    RootDir->LastWriteTime |= (TimeInfo->tm_min << 5);
    RootDir->LastWriteTime |= (TimeInfo->tm_hour << 11);

    RootDir->LastWriteDate |= TimeInfo->tm_mday;
    RootDir->LastWriteDate |= (TimeInfo->tm_mon << 5);
    RootDir->LastWriteDate |= (TimeInfo->tm_year - 80) << 9;

    RootDir->Attribute = 1;
    RootDir->ClusterLow = 2;
}

uint8_t
InjectFile(const char *Path)
{
    FILE *FileIn = fopen(Path, "rb");
    if (!FileIn)
        return 0;

    fseek(FileIn, 0, SEEK_END);

    if ((RootDir->Size = ftell(FileIn)) > 0x163E00)
        goto Error;

    uint16_t SectorI;
    uint16_t SectorM = RootDir->Size >> 9;

    fseek(FileIn, 0, SEEK_SET);
    for (SectorI = 0; SectorI < SectorM; SectorI++)
    {
        if (!(Clusters[SectorI] = malloc(0x200)))
            goto Error;

        if (!fread(Clusters[SectorI], 0x200, 0x1, FileIn))
            goto Error;

        SetCluster(SectorI + 2, SectorI + 3);
    }

    if ((SectorM = RootDir->Size & 0x1FF))
    {
        if (!(Clusters[SectorI] = malloc(0x200)))
            goto Error;

        memset(Clusters[SectorI], 0x0, 0x200);

        if (!fread(Clusters[SectorI], SectorM, 1, FileIn))
            goto Error;
    }

    /* Success: */
        SetCluster(SectorI + 2, 0xFF0);
        fclose(FileIn);
        StampFile(Path);
        return 1;

    Error:
        fclose(FileIn);
        return 0;
}
