#include <inj.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

uint8_t  *Clusters[2847];
uint8_t  *FAT;
DirEntry *RootDir;

void
SetCluster(uint16_t C, uint16_t N)
{
    *(uint16_t *)&FAT[(C >> 1) + C] |= (C & 1 ? N << 4 : N);
}

static uint8_t
Init(void)
{
    if (!(FAT = malloc(4608)))
        return 0;

    if (!(RootDir = malloc(7168)))
    {
        free(FAT);
        return 0;
    }

    memset(FAT, 0x00, 4608);
    memset(RootDir, 0x00, 7168);
    memset(RootDir->Name, 0x20, 11);
    memset(&Clusters, 0x00, sizeof(uint8_t *) * 2847);

    SetCluster(0, 0xFF8);
    SetCluster(1, 0xFFF);
    return 1;
}

static void
Deinit(void)
{
    for (uint16_t i = 0; i < 2847; i++)
    {
        if (Clusters[i])
            free(Clusters[i]);
    }

    free(FAT);
    free(RootDir);
}

int
main(int argc, char **argv)
{
    uint8_t RetVal = 0;

    if (argc < 4 || !Init())
    {
        printf
        (
            "inject [of] [bs] [if]\n"
            "        |    |    '--> File to inject.\n"
            "        |    '-------> Bootsector to use.\n"
            "        '------------> Output file.\n\n"
        );

        RetVal++;
    }
    else
    {
        RetVal = (InjectFile(argv[3]) ? 0 : 1);
        RetVal = (DumpImage(argv[1], argv[2]) ? 0 : 1);

        Deinit();
    }

    return RetVal;
}
